<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Solving the incompressible Navier-Stokes Equation &mdash; cflowpy Jule 2023 documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="_static/jquery.js"></script>
        <script src="_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/doctools.js"></script>
        <script src="_static/sphinx_highlight.js"></script>
        <script async="async" src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="prev" title="Integrator" href="integrator.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="index.html" class="icon icon-home">
            cflowpy
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">cflowpy:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="tutorial.html">Tutorial</a></li>
<li class="toctree-l1"><a class="reference internal" href="grid.html">Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="physical_problem.html">Physical Problem</a></li>
<li class="toctree-l1"><a class="reference internal" href="integrator.html">Integrator</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Solving the incompressible Navier-Stokes Equation</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#constructor">Constructor</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#src.System.__init__"><code class="docutils literal notranslate"><span class="pre">System.__init__()</span></code></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#solve">Solve</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#src.System.solve"><code class="docutils literal notranslate"><span class="pre">System.solve()</span></code></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#numerical-stability">Numerical stability</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#src.System.check_stability"><code class="docutils literal notranslate"><span class="pre">System.check_stability()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="#src.System.update_dt"><code class="docutils literal notranslate"><span class="pre">System.update_dt()</span></code></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#stepping-forward-in-time">Stepping forward in time</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#src.System.update_time"><code class="docutils literal notranslate"><span class="pre">System.update_time()</span></code></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#termination-criterion">Termination criterion</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#src.System.check_residual"><code class="docutils literal notranslate"><span class="pre">System.check_residual()</span></code></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#saving-the-results">Saving the results</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#src.System.save_data"><code class="docutils literal notranslate"><span class="pre">System.save_data()</span></code></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#visualization">Visualization</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#src.System.contourfigure"><code class="docutils literal notranslate"><span class="pre">System.contourfigure()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="#src.System.create_gif"><code class="docutils literal notranslate"><span class="pre">System.create_gif()</span></code></a></li>
</ul>
</li>
</ul>
</li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">cflowpy</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home" aria-label="Home"></a></li>
      <li class="breadcrumb-item active">Solving the incompressible Navier-Stokes Equation</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/system.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="solving-the-incompressible-navier-stokes-equation">
<h1>Solving the incompressible Navier-Stokes Equation<a class="headerlink" href="#solving-the-incompressible-navier-stokes-equation" title="Permalink to this heading"></a></h1>
<div class="line-block">
<div class="line">This is the heart of cflowpy.</div>
<div class="line"><code class="docutils literal notranslate"><span class="pre">System</span></code> describes the system on which we want to simulate the
incompressible Navier Stokes Equation.</div>
</div>
<blockquote>
<div><div class="admonition warning">
<p class="admonition-title">Warning</p>
<div class="line-block">
<div class="line">Take care of how to choose the discretization, when
initializing the <code class="docutils literal notranslate"><span class="pre">System</span></code>.</div>
<div class="line">A to coarse discretization might lead to unstable results and a
to fine discretization might lead to overflow errors.</div>
<div class="line">For some suggestions on implemented physical problems see the
documentation of those in <a class="reference internal" href="physical_problem.html"><span class="doc">Physical Problem</span></a></div>
</div>
</div>
</div></blockquote>
<dl class="py class">
<dt class="sig sig-object py">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">src.</span></span><span class="sig-name descname"><span class="pre">System</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xBegin</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">xEnd</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">nCellsX</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">yBegin</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">yEnd</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">nCellsY</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">viscosity</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">density</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">physical_problem</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">type</span><span class="p"><span class="pre">[</span></span><span class="pre">src.physical_problem.PhysicalProblem</span><span class="p"><span class="pre">]</span></span></span></em><span class="sig-paren">)</span></dt>
<dd><p>This class is used to solve the incompressible Navier-Stokes equation in
the momentum equation with Chorins projection method.</p>
<p>∂u/∂t + (u • ∇)u = -1/ρ ∇p + ν∇²u + g</p>
<p>With the constraint ∇ • u = 0 for incompressibility.</p>
<p>In Terms of variables we talk about
u: flow velocity
t: time
ρ: density
p: pressure
ν: kinematic viscosity
g: body accelerations</p>
<p>In this case we use g=0.
The velocity field (u) lives in 2 dimensions.
The velocity in x-direction and the one in y-direction.
In our case we use a common definition and work with u as the velocity
in x-direction and v as the velocity in y-direction.
The density and the kinematic viscosity are needed to be defined
by construction.</p>
<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">grid</span></span></dt>
<dd><p>An Instance of the class Grid to define the
discretized physical domain</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>Grid</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">physical_problem</span></span></dt>
<dd><p>Defines the physical state of the problem.</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>PhysicalProblem</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">viscosity</span></span></dt>
<dd><p>The kinematic viscosity of the fluid</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">density</span></span></dt>
<dd><p>The density of the fluid</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">integrator</span></span></dt>
<dd><p>Used for time integration</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>Integrator</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">dx</span></span></dt>
<dd><p>Size between two points in x-direction of the physical domain</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">dy</span></span></dt>
<dd><p>size between two points in y-direction of the physical domain</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">dt</span></span></dt>
<dd><p>Initial length of the time step</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">time_update</span></span></dt>
<dd><p>Method to step forward in time</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>str</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">adapt_dt</span></span></dt>
<dd><p>Used to adapt the length of a time step if the
cfl condition is not fullfilled</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">adaptive_step_size_tolerance</span></span></dt>
<dd><p>Tolerance to adapt the time step to get a higher
accuracy for the time integration</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>float, int</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">dt_used</span></span></dt>
<dd><p>Used length of time step if a adaptive step size method is chosen
Step size is adapted in the intermediate time step and then the
adapted step size is used for the “final” update in time in each step</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<section id="constructor">
<h2>Constructor<a class="headerlink" href="#constructor" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">The Constructor specifies the physical domain, the viscosity
and density of the fluid.</div>
<div class="line">Furthermore, it describes the physical state of the
problem, which specifies the initial state and the boundary conditions.</div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="src.System.__init__">
<span class="sig-prename descclassname"><span class="pre">System.</span></span><span class="sig-name descname"><span class="pre">__init__</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xBegin</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">xEnd</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">nCellsX</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">yBegin</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">yEnd</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">nCellsY</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">viscosity</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">density</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">physical_problem</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">type</span><span class="p"><span class="pre">[</span></span><span class="pre">src.physical_problem.PhysicalProblem</span><span class="p"><span class="pre">]</span></span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.System.__init__" title="Permalink to this definition"></a></dt>
<dd><p>Constructor</p>
<p>Generates an instance of the class Chorin.
Assigns the grid, physical problem, viscosity and the density
to the associated class Attributes.
Explicit Euler is assigned as the “default” time integration.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>xBegin</strong> (<em>float</em>) – Left side of the domain</p></li>
<li><p><strong>xEnd</strong> (<em>float</em>) – Right side of the domain</p></li>
<li><p><strong>nCellsX</strong> (<em>int</em>) – Number of Cells in x-direction</p></li>
<li><p><strong>yBegin</strong> (<em>float</em>) – Lower side of the domain</p></li>
<li><p><strong>yEnd</strong> (<em>float</em>) – Upper side of the domain</p></li>
<li><p><strong>nCellsY</strong> (<em>int</em>) – Number of Cells in y-direction</p></li>
<li><p><strong>viscosity</strong> (<em>float</em>) – The kinematic viscosity of the fluid</p></li>
<li><p><strong>density</strong> (<em>float</em>) – The density of the fluid</p></li>
<li><p><strong>physical_problem</strong> (<em>PhysicalProblem</em>) – Defines the physical state of the problem</p></li>
</ul>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><ul class="simple">
<li><p><strong>ValueError</strong> – If the end of the domain in x-direction is lower then
    the begin of the domain in x-direction</p></li>
<li><p><strong>ValueError</strong> – If the end of the domain in y-direction is lower then
    the begin of the domain in y-direction</p></li>
<li><p><strong>ValueError</strong> – If the number of cells in x or y-direction is no positive number,
    at least 1 cell is required</p></li>
<li><p><strong>TypeError</strong> – If the number of cells in x or y-direction is no integer</p></li>
<li><p><strong>ValueError</strong> – If Viscosity is negative</p></li>
<li><p><strong>ValueError</strong> – If Density is lower or equal to zero</p></li>
<li><p><strong>TypeError</strong> – If physical_problem is not of the type PhysicalProblem</p></li>
</ul>
</dd>
</dl>
</dd></dl>

</section>
<section id="solve">
<h2>Solve<a class="headerlink" href="#solve" title="Permalink to this heading"></a></h2>
<div class="admonition note">
<p class="admonition-title">Note</p>
<div class="line-block">
<div class="line">This is the function which gives us the possibility to predict the
velocity and pressure field of an incompressible fluid, since this
function solve the incompressible Navier-Stokes equation.</div>
</div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="src.System.solve">
<span class="sig-prename descclassname"><span class="pre">System.</span></span><span class="sig-name descname"><span class="pre">solve</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">dt</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">t_end</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">time_update</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">'explicit_Euler'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">residual</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><span class="pre">None</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">n_iteration_pressure_poisson</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">100</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">residual_pressure_poisson</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><span class="pre">None</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">history</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">bool</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">adapt_dt</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><span class="pre">None</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">adaptive_step_size_tolerance</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><span class="pre">None</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">save_data</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><span class="pre">None</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.System.solve" title="Permalink to this definition"></a></dt>
<dd><p>Calculates the solution for the incompressible Navier-Stokes Equation
in the momentum equation with Chorin’s Projection method.</p>
<p>This Algorithm is a splitted Algorithm.
First, only the viscous forces are taken into account and an
intermediate velocity is calculated.
Second, the pressure forces are taken into account.
Therefore a Poisson equation has to be solved and then the
velocity is updated in time.
This is done till the final time is reached or if a residual is give
till the differnce between two time steps is very small.</p>
<p>In each time-step it is checked if the cfl-condition is fullfilled.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>dt</strong> (<em>float</em>) – Length of time step</p></li>
<li><p><strong>t_end</strong> (<em>int</em>) – End time</p></li>
<li><p><strong>time_update</strong> (<em>str</em><em>, </em><em>optional</em>) – Method to step forward in time
Has to be one of the methods that is implemented in Integrator
Default is “explicitEuler”</p></li>
<li><p><strong>residual</strong> (<em>float optional</em>) – Decides whether the calculations should be stopped
if the difference in the norm of two following time steps
is lower than the residual (float),
by default None</p></li>
<li><p><strong>n_iteration_pressure_poisson</strong> (<em>float optional</em>) – Number of maximum iteration to solve the pressure poisson equation</p></li>
<li><p><strong>residual_pressure_poisson</strong> (<em>float</em><em>, </em><em>None optional</em>) – Decides wheter the calculations to solve the pressure poisson
equation should be stopped at a small change in two consecutive
iterations or run “n_iteration_pressure_poisson” steps</p></li>
<li><p><strong>history</strong> (<em>bool</em><em>, </em><em>optional</em>) – If False: Return values are the ones in the last time step
stored in numpy.ndarrays of dimension (nPointsY, nPointsX)
If True: Return values are those in every time step stored in a
list each time step is a numpy.ndarray of dimension
(nPointsY, nPointsX),
by default False</p></li>
<li><p><strong>adapt_dt</strong> (<em>float</em><em>, </em><em>optional</em>) – The cfl-number is checked in every time step.
If adapt_dt is not specified and the cfl-condition is not
fullfilled the iteration will stop and return the last values.
If adapt_dt is defined, dt will be adapted in a way that the
cfl-number is set to this value.
Choose a value between 0 and 1 for adapt_dt.
For good numerical results a value between 0.5 and 0.8
is suggested.
A value close to 1 is not suggested since this leads to a
edge stable case, which can lead to errors, non physical results
or results going to infinity. Be careful with this since this can
lead to very small time steps which can cause a very long
compute time.
By default None</p></li>
<li><p><strong>adaptive_step_size_tolerance</strong> (<em>float</em><em>, </em><em>optional</em>) – If adaptive_step_size_dt is specified the time integration will
use a method to adapt the step size in each time update to gain
a higher accuracy according to the adaptive_step_size_tolerance,
by default None</p></li>
</ul>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><ul class="simple">
<li><p><strong>ValueError</strong> – If dt is smaller or equal to zero</p></li>
<li><p><strong>TypeError</strong> – If the end time is no integer or float</p></li>
<li><p><strong>ValueError</strong> – If the end time is lower or equal to zero</p></li>
<li><p><strong>ValueError</strong> – If the given time update method is not implemented</p></li>
<li><p><strong>ValueError</strong> – If the residual is given but lower or equal to zero
    Then the same is achieved as to give no residual</p></li>
<li><p><strong>TypeError</strong> – If “history” is no boolean</p></li>
<li><p><strong>TypeError</strong> – If adapt_dt is specified, but no float</p></li>
<li><p><strong>ValueError</strong> – If adapt_dt is specified, but not between 0 and 1</p></li>
<li><p><strong>TypeError</strong> – If adaptive_step_size_tolerance is specified but no number</p></li>
<li><p><strong>ValueError</strong> – If adaptive_step_size_tolerance is specified
    but lower or equal to zero</p></li>
</ul>
</dd>
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p><ul class="simple">
<li><p><em>np.ndarray, np.ndarray, np.ndarray |</em></p></li>
<li><p><em>list[np.ndarray], list[np.ndarray], list[np.ndarray]</em> – Returns velocity in x- and y-direction as well as the
pressure-field.</p></li>
</ul>
</p>
</dd>
</dl>
</dd></dl>

</section>
<section id="numerical-stability">
<h2>Numerical stability<a class="headerlink" href="#numerical-stability" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">The cfl-condition is a widely used condition to check for numerical stability.</div>
<div class="line">For this kind of simulation we want to fullfill this condition.</div>
</div>
<blockquote>
<div><ul class="simple">
<li><p>The cfl-number is: <span class="math notranslate nohighlight">\(\frac{u \cdot dt}{dx}\)</span></p></li>
</ul>
</div></blockquote>
<dl class="py method">
<dt class="sig sig-object py" id="src.System.check_stability">
<span class="sig-prename descclassname"><span class="pre">System.</span></span><span class="sig-name descname"><span class="pre">check_stability</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">u</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">v</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">time</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.System.check_stability" title="Permalink to this definition"></a></dt>
<dd><p>Checks for stability of numerical method.</p>
<p>Checks the cfl-condition.
We want to fullfill the condition that the absolute value
of the cfl-number is not lower 0 or higher then 1.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>u</strong> (<em>np.ndarray</em>) – Velocity in x-direction</p></li>
<li><p><strong>v</strong> (<em>np.ndarray</em>) – Velocity in y-direction</p></li>
<li><p><strong>time</strong> (<em>float</em>) – Current time</p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>Returns True if the stability constraint is fullfilled, else False</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p>bool</p>
</dd>
</dl>
</dd></dl>

<div class="line-block">
<div class="line">If the cfl-condition is not fullfilled there are two possibilities.</div>
<div class="line">First, if one wants to continue with the computations it would be good to
adapt some values to ensure that the cfl-condition is fullfilled again.</div>
<div class="line">Since u and dx are fixed the only way to ensure stability is to change dt.</div>
<div class="line">Second, one could stop the simulation and work with the results till the time
the cfl-condition broke.</div>
</div>
<div class="line-block">
<div class="line">If it is wished to adapt the time step size to fullfill the cfl-condition
this is done with</div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="src.System.update_dt">
<span class="sig-prename descclassname"><span class="pre">System.</span></span><span class="sig-name descname"><span class="pre">update_dt</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">cfl</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">u</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">v</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.System.update_dt" title="Permalink to this definition"></a></dt>
<dd><p>Updates the time step size.</p>
<p>The cfl-condition should be fullfilled for this simulation.
If the cfl-condition is not fullfilled one can use this function
to update the time step length, such that the cfl-condition
is fullfilled again.
There is no need to check that the maximum of the absolute value
of u or v is zero since the cfl-condition would be satisfied
for this case.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>cfl</strong> (<em>np.ndarray</em>) – Maximum cfl-number in x and y-direction</p></li>
<li><p><strong>u</strong> (<em>np.ndarray</em>) – Velocity in x-direction</p></li>
<li><p><strong>v</strong> (<em>np.ndarray</em>) – Velocity in y-direction</p></li>
</ul>
</dd>
</dl>
</dd></dl>

</section>
<section id="stepping-forward-in-time">
<h2>Stepping forward in time<a class="headerlink" href="#stepping-forward-in-time" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">The incompressible Navier-Stokes Equation is a time dependant PDE.</div>
<div class="line">This means, a method to step forward in time is needed.</div>
<div class="line">Therefore, <a class="reference internal" href="integrator.html#integrator"><span class="std std-ref">Integrator</span></a> is used.</div>
<div class="line">It is possible to choose between the implemented
methods in <a class="reference internal" href="integrator.html#integrator"><span class="std std-ref">Integrator</span></a>.</div>
<div class="line">Another possibility is to use an <a class="reference internal" href="integrator.html#adaptive-step-size-method"><span class="std std-ref">Adaptive step size method</span></a>, which adapts
the step size in each time step to reach a higher accuracy.</div>
<div class="line">However, this can lead to a higher compute time since the time steps
can get arbitrary small.</div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="src.System.update_time">
<span class="sig-prename descclassname"><span class="pre">System.</span></span><span class="sig-name descname"><span class="pre">update_time</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">u</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">u_rhs</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">v</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">v_rhs</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">second</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.System.update_time" title="Permalink to this definition"></a></dt>
<dd><p>Updates the velocity in time with the given method</p>
<p>Note: No type checking is implemented since this method is only called
in the function “system” where all necessary types are checked.
Thus, it is highly recommended to check all necessary conditions
if this method is used out of this scope</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>u</strong> (<em>np.ndarray</em>) – Velocity in x-direction</p></li>
<li><p><strong>u_rhs</strong> (<em>np.ndarray</em>) – RHS of the equation to update velocity in x-direction</p></li>
<li><p><strong>v</strong> (<em>np.ndarray</em>) – Velocity in y-direction</p></li>
<li><p><strong>v_rhs</strong> (<em>np.ndarray</em>) – RHS of the equation to update velocity in y-direction</p></li>
<li><p><strong>dt</strong> (<em>float</em>) – Length of time step</p></li>
<li><p><strong>method</strong> (<em>function</em>) – Method to update the velocities in time</p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>Updated velocities in time</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p>np.ndarray, np.ndarray</p>
</dd>
</dl>
</dd></dl>

</section>
<section id="termination-criterion">
<h2>Termination criterion<a class="headerlink" href="#termination-criterion" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">The matter of interest could be a case where neither the velocities
nor the pressure changes over time.</div>
<div class="line"><code class="docutils literal notranslate"><span class="pre">check_residual</span></code> enables the possibility to stop the computation
when the change in two consecutive time steps is smaller
then a <code class="docutils literal notranslate"><span class="pre">residual</span></code>.</div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>The computations will still be stopped if the final time is achieved.
To achieve a case with no changes over time it is still important
to pass an end time which is high enough to ensure this.</p>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="src.System.check_residual">
<span class="sig-prename descclassname"><span class="pre">System.</span></span><span class="sig-name descname"><span class="pre">check_residual</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">u</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">v</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">p</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">residual</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><span class="pre">None</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.System.check_residual" title="Permalink to this definition"></a></dt>
<dd><p>Checks if the simulation should be stopped according to the residual.</p>
<p>If the norm in the current time step subtracted to the norm of the
last time step is smaller then the residual the simulation stops
This is checked for all, the velocity in x- and y-direction
as well as the pressure field.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>u</strong> (<em>np.ndarray</em>) – Velocity in x-direction</p></li>
<li><p><strong>v</strong> (<em>np.ndarray</em>) – Velocity in y-direction</p></li>
<li><p><strong>p</strong> (<em>np.ndarray</em>) – Pressure field</p></li>
<li><p><strong>residual</strong> (<em>float</em><em>, </em><em>optional</em>) – The residual to stop the iteration, by default None</p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>False if the iteration should be stopped according to the residual
If no residual is specified True is returned</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p>bool</p>
</dd>
</dl>
</dd></dl>

</section>
<section id="saving-the-results">
<h2>Saving the results<a class="headerlink" href="#saving-the-results" title="Permalink to this heading"></a></h2>
<p>The results can be saved in a <strong>.npz</strong> file for reproducibility.</p>
<dl class="py method">
<dt class="sig sig-object py" id="src.System.save_data">
<span class="sig-prename descclassname"><span class="pre">System.</span></span><span class="sig-name descname"><span class="pre">save_data</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">file</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">u</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">v</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">p</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">dt</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">t_end</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">residual</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">n_iteration_pressure_poisson</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">residual_pressure_poisson</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">adapt_dt</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.System.save_data" title="Permalink to this definition"></a></dt>
<dd><p>Saves the simulation results with the simulation parameter.</p>
<p>The results and parameters are saved in a single
uncompressed .npz file.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>file</strong> (<em>str</em>) – File to save the results and parameter</p></li>
<li><p><strong>u</strong> (<em>np.ndarray</em>) – Velocity in x-direction</p></li>
<li><p><strong>v</strong> (<em>np.ndarray</em>) – Velocity in y-direction</p></li>
<li><p><strong>p</strong> (<em>np.ndarray</em>) – Pressure field</p></li>
<li><p><strong>dt</strong> (<em>float</em>) – Length of time step at beginning of simulation</p></li>
<li><p><strong>t_end</strong> (<em>float</em>) – End time of the simulation</p></li>
<li><p><strong>residual</strong> (<em>float</em>) – Residual, if used to stop at convergence</p></li>
<li><p><strong>n_iteration_pressure_poisson</strong> (<em>int</em>) – Number of iteration for the jacobi method to solve
the poisson equation</p></li>
<li><p><strong>residual_pressure_poisson</strong> (<em>float</em>) – Residual for the poisson equation to stop at convergence</p></li>
<li><p><strong>adapt_dt</strong> (<em>float</em>) – cfl-condition constraint</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<div class="line-block">
<div class="line">To read the .npz file numpys load function can be used.</div>
<div class="line">Every value can be accessed in a dictionary-like object.</div>
<div class="line">For example it is possible to read the data and access
the discretization in x-direction with the following:</div>
</div>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">npzfile</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">outfile</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">npzfile</span><span class="p">[</span><span class="s2">&quot;x&quot;</span><span class="p">]</span>
</pre></div>
</div>
</section>
<section id="visualization">
<h2>Visualization<a class="headerlink" href="#visualization" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">It is possible to the visualize the results of the simulation.</div>
<div class="line">Two functions are available to do so.</div>
<div class="line"><code class="docutils literal notranslate"><span class="pre">contourfigure</span></code> visualizes a specific time point of the simulation,
most likely the final state.</div>
<div class="line"><code class="docutils literal notranslate"><span class="pre">create_gif</span></code> creates a gif to visualize the change of
velocity and pressure over time.</div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="src.System.contourfigure">
<span class="sig-prename descclassname"><span class="pre">System.</span></span><span class="sig-name descname"><span class="pre">contourfigure</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">u</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">v</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">p</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">contour</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">bool</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">title</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><span class="pre">None</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">xlabel</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">'X'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">ylabel</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">'Y'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">figsize</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">tuple</span><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><span class="pre">None</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">velocity</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">'quiver'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">alpha</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><span class="pre">None</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">velocity_color</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">'black'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">velocity_profile</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">list</span><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><span class="pre">None</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">cmap</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">'viridis'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">colorbar</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">bool</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">savefig</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><span class="pre">None</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.System.contourfigure" title="Permalink to this definition"></a></dt>
<dd><p>Generates a figure to visualize the simulation results.</p>
<p>Can visualize the pressure as a contourfigure as well as the
the velocity field and the streamlines.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>u</strong> (<em>np.ndarray</em>) – velocity in x-direction</p></li>
<li><p><strong>v</strong> (<em>np.ndarray</em>) – velocity in y-direction</p></li>
<li><p><strong>p</strong> (<em>np.ndarray</em>) – pressure field</p></li>
<li><p><strong>contour</strong> (<em>bool</em><em>, </em><em>optional</em>) – If true, visualizes the pressure as a contourfigure,
by default True</p></li>
<li><p><strong>title</strong> (<em>str</em><em>, </em><em>optional</em>) – Title of the figure, by default None</p></li>
<li><p><strong>xlabel</strong> (<em>str</em><em>, </em><em>optional</em>) – Label of the x-axis, by default “X”</p></li>
<li><p><strong>ylabel</strong> (<em>str</em><em>, </em><em>optional</em>) – Label of the y-axis, by default “Y”</p></li>
<li><p><strong>figsize</strong> (<em>tuple</em><em>, </em><em>optional</em>) – Size of the figure, by default (6,6)</p></li>
<li><p><strong>velocity</strong> (<em>str</em><em>, </em><em>optional</em>) – method to visualize the velocity, choose “quiver” to get the
velocity field and “streamline” to get the streamlines visualized,
by default “quiver”</p></li>
<li><p><strong>alpha</strong> (<em>float</em><em>, </em><em>optional</em>) – alpha value for the quivers in matplotlib.pyplot.quiver,
by default None</p></li>
<li><p><strong>velocity_color</strong> (<em>str</em><em>, </em><em>optional</em>) – Color of the visualized velocities, by default “black”</p></li>
<li><p><strong>velocity_profile</strong> (<em>list</em><em>, </em><em>optional</em>) – Visualizes the velocity profile at the x-points specified
in the argument, by default None</p></li>
<li><p><strong>cmap</strong> (<em>str</em><em>, </em><em>optional</em>) – Colormap used for the contourfigure, by default “viridis”</p></li>
<li><p><strong>colorbar</strong> (<em>bool</em><em>, </em><em>optional</em>) – Adds a colorbar for the pressure, by default True</p></li>
<li><p><strong>savefig</strong> (<em>str</em><em>, </em><em>optional</em>) – specifies in which file to save the visualization, by default None</p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>Visualized results</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p>matplotlib.pyplto.figure</p>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><ul class="simple">
<li><p><strong>TypeError</strong> – u, v or p is no np.ndarray</p></li>
<li><p><strong>TypeError</strong> – contour is no boolean</p></li>
<li><p><strong>TypeError</strong> – title is specified but no string</p></li>
<li><p><strong>TypeError</strong> – x- or ylabel is no string</p></li>
<li><p><strong>TypeError</strong> – figsize is no tuple</p></li>
<li><p><strong>ValueError</strong> – velocity is neither quiver nor streamline</p></li>
<li><p><strong>TypeError</strong> – alpha is no float</p></li>
<li><p><strong>ValueError</strong> – alpha is not in the range of (0,1)</p></li>
<li><p><strong>TypeError</strong> – velocity_color is no string</p></li>
<li><p><strong>TypeError</strong> – velocity_profile is not list</p></li>
<li><p><strong>TypeError</strong> – cmap is no string</p></li>
<li><p><strong>TypeError</strong> – colorbar is no boolean</p></li>
<li><p><strong>TypeError</strong> – savefig is specified but no string</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="src.System.create_gif">
<span class="sig-prename descclassname"><span class="pre">System.</span></span><span class="sig-name descname"><span class="pre">create_gif</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">savefig</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">u</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">list</span><span class="p"><span class="pre">[</span></span><span class="pre">numpy.ndarray</span><span class="p"><span class="pre">]</span></span></span></em>, <em class="sig-param"><span class="n"><span class="pre">v</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">list</span><span class="p"><span class="pre">[</span></span><span class="pre">numpy.ndarray</span><span class="p"><span class="pre">]</span></span></span></em>, <em class="sig-param"><span class="n"><span class="pre">p</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">list</span><span class="p"><span class="pre">[</span></span><span class="pre">numpy.ndarray</span><span class="p"><span class="pre">]</span></span></span></em>, <em class="sig-param"><span class="n"><span class="pre">contour</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">bool</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">title</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><span class="pre">None</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">xlabel</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">'X'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">ylabel</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">'Y'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">figsize</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">tuple</span><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><span class="pre">None</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">velocity</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">'quiver'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">alpha</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><span class="pre">None</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">velocity_color</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">'black'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">velocity_profile</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">list</span><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><span class="pre">None</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">cmap</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">'viridis'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">colorbar</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">bool</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">skip_time</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">duration</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">5</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">time_digits</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">4</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">loop</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">0</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.System.create_gif" title="Permalink to this definition"></a></dt>
<dd><p>Generates an animated gif to visualize the simulation results.</p>
<p>Can visualize the pressure as a contourfigure as well as the
the velocity field and the streamlines.
Note, the typecheks that are done in <code class="docutils literal notranslate"><span class="pre">contourfigure</span></code> are not
repeated here, since this function calls <code class="docutils literal notranslate"><span class="pre">contourfigure</span></code> and
so these values are checked.
Saves the animated gif in the file specified in savefig.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>u</strong> (<em>list</em><em>[</em><em>np.ndarray</em><em>]</em>) – velocity in x-direction over time</p></li>
<li><p><strong>v</strong> (<em>list</em><em>[</em><em>np.ndarray</em><em>]</em>) – velocity in y-direction over time</p></li>
<li><p><strong>p</strong> (<em>list</em><em>[</em><em>np.ndarray</em><em>]</em>) – pressure field over time</p></li>
<li><p><strong>savefig</strong> (<em>str</em>) – specifies in which file to save the gif, by default None</p></li>
<li><p><strong>contour</strong> (<em>bool</em><em>, </em><em>optional</em>) – If true, visualizes the pressure as a contourfigure,
by default True</p></li>
<li><p><strong>title</strong> (<em>str</em><em>, </em><em>optional</em>) – Title of the figure, by default None, by default None</p></li>
<li><p><strong>xlabel</strong> (<em>str</em><em>, </em><em>optional</em>) – Label of the x-axis, by default “X”</p></li>
<li><p><strong>ylabel</strong> (<em>str</em><em>, </em><em>optional</em>) – Label of the y-axis, by default “Y”</p></li>
<li><p><strong>figsize</strong> (<em>tuple</em><em>, </em><em>optional</em>) – Size of the figure, by default None</p></li>
<li><p><strong>velocity</strong> (<em>str</em><em>, </em><em>optional</em>) – <dl class="simple">
<dt>method to visualize the velocity, choose “quiver” to get the</dt><dd><p>velocity field and “streamline” to get the streamlines visualized,
by default “quiver”</p>
</dd>
</dl>
</p></li>
<li><p><strong>alpha</strong> (<em>float</em><em>, </em><em>optional</em>) – alpha value for the quivers in matplotlib.pyplot.quiver,
by default None</p></li>
<li><p><strong>velocity_color</strong> (<em>str</em><em>, </em><em>optional</em>) – Color of the visualized velocities, by default “black”</p></li>
<li><p><strong>velocity_profile</strong> (<em>list</em><em>, </em><em>optional</em>) – Visualizes the velocity profile at the x-points specified
in the argument, by default None</p></li>
<li><p><strong>cmap</strong> (<em>str</em><em>, </em><em>optional</em>) – Colormap used for the contourfigure, by default “viridis”</p></li>
<li><p><strong>colorbar</strong> (<em>bool</em><em>, </em><em>optional</em>) – Adds a colorbar for the pressure, by default True</p></li>
<li><p><strong>skip_time</strong> (<em>float</em><em>, </em><em>optional</em>) – Skips time steps to visualize not every singel time step, by default 1</p></li>
<li><p><strong>duration</strong> (<em>int</em><em>, </em><em>optional</em>) – duration each frame lasts[ms], by default 5</p></li>
<li><p><strong>time_digits</strong> (<em>int</em><em>, </em><em>optional</em>) – digits of the time[s], by default 4</p></li>
<li><p><strong>loop</strong> (<em>int</em><em>, </em><em>optional</em>) – how often the gif repeats, 0 for endless repetition, by default 0</p></li>
</ul>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><ul class="simple">
<li><p><strong>TypeError</strong> – u, v or p is no list</p></li>
<li><p><strong>TypeError</strong> – figsize is specified but no tuple</p></li>
<li><p><strong>TypeError</strong> – skip_time is no number</p></li>
<li><p><strong>TypeError</strong> – duration is no integer</p></li>
<li><p><strong>TypeError</strong> – time_digits is no integer</p></li>
<li><p><strong>TypeError</strong> – loop is no integer</p></li>
</ul>
</dd>
</dl>
</dd></dl>

</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="integrator.html" class="btn btn-neutral float-left" title="Integrator" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2023, Jan Habscheid.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>